struct jmpbuf2 {
	int r2, r3, r4, r5, sp, pc, stack, len;
} caller, callee;
char buf[128];
int value, state, (*func)();

initcr(f) {
	state = 0;
	func = f;
}

callcr() {
	if (setjmp2(&caller)) return 1;
	switch (state) {
	case 0:
		state = 1;
		(*func)();
		state = 3;
		break;
	case 2:
		state = 1; /**/
		longjmp2(&callee, 1);
	}
	return 0;
}

yield(v) {
	if (setjmp2(&callee) == 0) {
		callee.len = caller.sp - callee.sp;
		callee.stack = buf;
		memcpy(buf, callee.sp, callee.len);
		value = v;
		state = 2;
		longjmp2(&caller, 1);
	}
	return value;
}

test() {
	int i;
	for (i = 0; i < 5; i++)
		yield(i);
}

main() {
	initcr(test);
	while (callcr())
		printf("%d\n", value);
}
